// Thinkingdata WEEX SDK v2.0.0
package cn.thinkingdata.android.weex;

import com.taobao.weex.annotation.JSMethod;
import com.taobao.weex.common.WXModule;

import org.json.JSONException;
import org.json.JSONObject;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.TimeZone;

import cn.thinkingdata.android.ThinkingAnalyticsSDK;

public class WeexThinkingDataAnalyticsModule extends WXModule {

    private static final String MODULE_NAME = "WeexThinkingDataAnalyticsModule";

    private JSONObject convertToJSONObject(com.alibaba.fastjson.JSONObject properties) {
        JSONObject json = new JSONObject();
        if (properties == null) {
            return json;
        }

        try {
            json = new JSONObject(properties.toString());
        } catch (Exception e) {
            e.printStackTrace();
        }

        return json;
    }

    @JSMethod(uiThread = true)
    public void track(HashMap options) {
        try {
            String appId = (String)options.get("appId");
            String eventName = (String)options.get("eventName");

            JSONObject properties = null;
            if (options.containsKey("properties")) {
                properties = (convertToJSONObject((com.alibaba.fastjson.JSONObject) options.get("properties")));
            }

            if (options.containsKey("time")) {
                Long time = (Long) options.get("time");
                Date date = new Date((long) (time));
                TimeZone tz = null;
                if (options.containsKey("timeZone")) {
                    String timeZone = (String) options.get("timeZone");
                    tz = TimeZone.getTimeZone(timeZone);
                }
                if (null == tz) {
                    ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).track(eventName, properties, date);
                } else {
                    ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).track(eventName, properties, date, tz);
                }
            } else {
                ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).track(eventName, properties);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void timeEvent(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            String eventName = (String) options.get("eventName");
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).timeEvent(eventName);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void login(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            String loginId = (String) options.get("loginId");
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).login(loginId);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void logout(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).logout();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void userSet(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            JSONObject properties = null;
            if (options.containsKey("properties")) {
                properties = (convertToJSONObject((com.alibaba.fastjson.JSONObject) options.get("properties")));
            }
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).user_set(properties);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void userUnset(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            String properties = null;
            if (options.containsKey("properties")) {
                properties = (String) options.get("properties");
            }
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).user_unset(properties);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void userSetOnce(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            JSONObject properties = null;
            if (options.containsKey("properties")) {
                properties = (convertToJSONObject((com.alibaba.fastjson.JSONObject) options.get("properties")));
            }
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).user_setOnce(properties);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void userAdd(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            JSONObject properties = null;
            if (options.containsKey("properties")) {
                properties = (convertToJSONObject((com.alibaba.fastjson.JSONObject) options.get("properties")));
            }
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).user_add(properties);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void userDel(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).user_delete();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void userAppend(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            JSONObject properties = null;
            if (options.containsKey("properties")) {
                properties = (convertToJSONObject((com.alibaba.fastjson.JSONObject) options.get("properties")));
            }
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).user_append(properties);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void setSuperProperties(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            JSONObject properties = null;
            if (options.containsKey("properties")) {
                properties = (convertToJSONObject((com.alibaba.fastjson.JSONObject) options.get("properties")));
            }
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).setSuperProperties(properties);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void unsetSuperProperty(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            String properties = null;
            if (options.containsKey("properties")) {
                properties = (String) options.get("properties");
            }
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).unsetSuperProperty(properties);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void clearSuperProperties(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).clearSuperProperties();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void identify(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            String distinctId = null;
            if (options.containsKey("distinctId")) {
                distinctId = (String) options.get("distinctId");
            }
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).identify(distinctId);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void flush(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).flush();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void enableTracking(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            Boolean enableTracking = false;
            if (options.containsKey("enableTracking")) {
                enableTracking = (Boolean) options.get("enableTracking");
            }
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).enableTracking(enableTracking);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void optInTracking(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).optInTracking();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void optOutTracking(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).optOutTracking();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void optOutTrackingAndDeleteUser(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).optOutTrackingAndDeleteUser();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void enableAutoTrack(HashMap options) {
        try {
            String appId = (String) options.get("appId");
            com.alibaba.fastjson.JSONObject autoTrackType = null;
            if (options.containsKey("autoTrackType")) {
                autoTrackType = (com.alibaba.fastjson.JSONObject) options.get("autoTrackType");
            }

            List<ThinkingAnalyticsSDK.AutoTrackEventType> eventTypeList = new ArrayList<>();
            if (autoTrackType.containsKey("appStart")) {
                eventTypeList.add(ThinkingAnalyticsSDK.AutoTrackEventType.APP_START);
            }
            if (autoTrackType.containsKey("appEnd")) {
                eventTypeList.add(ThinkingAnalyticsSDK.AutoTrackEventType.APP_END);
            }
            if (autoTrackType.containsKey("appCrash")) {
                eventTypeList.add(ThinkingAnalyticsSDK.AutoTrackEventType.APP_CRASH);
            }
            if (autoTrackType.containsKey("appInstall")) {
                eventTypeList.add(ThinkingAnalyticsSDK.AutoTrackEventType.APP_INSTALL);
            }

            ThinkingAnalyticsSDK.sharedInstance(mWXSDKInstance.getContext(), appId).enableAutoTrack(eventTypeList);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void calibrateTime(HashMap options) {
        try {
            Integer timeStampMillis = 0;
            if (options.containsKey("timeStampMillis")) {
                timeStampMillis = (Integer) options.get("timeStampMillis");
            }
            ThinkingAnalyticsSDK.calibrateTime((long)timeStampMillis);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    @JSMethod(uiThread = true)
    public void calibrateTimeWithNtp(HashMap options) {
        try {
            String ntpServer = null;
            if (options.containsKey("ntpServer")) {
                ntpServer = (String) options.get("ntpServer");
            }
            ThinkingAnalyticsSDK.calibrateTimeWithNtp(ntpServer);
        } catch (Exception e) {
            e.printStackTrace();
        }
    }
}